#ifndef _GRP_H
#define _GRP_H

#ifndef _COMPILER_H
#include <compiler.h>
#endif

#if defined(__USE_SVID) || defined (__USE_GNU)
#ifndef _STDIO_H
#define __need_FILE
#include <stdio.h>
#undef __need_FILE
#endif
#endif /* SVID or GNU*/

#ifdef __cplusplus
extern "C" {
#endif

struct group
{
  char *gr_name;    /* The name of the group        */
  _GID_T gr_gid;    /* The numerical group ID       */
  char **gr_mem;    /* array of member names        */
  char *__gr_passwd;/* The encrypted group password */
};

#if defined (__USE_SVID) || defined (__USE_MISC) || defined (__USE_BSD)
#define gr_passwd __gr_passwd
__EXTERN void   setgrent __PROTO((void));
__EXTERN void   endgrent __PROTO((void));
__EXTERN struct group * getgrent __PROTO((void));
#endif /* SVID or misc or BSD */

#ifdef __USE_SVID
__EXTERN struct group * fgetgrent __PROTO((FILE *f));
#endif /* __USE_SVID */

__EXTERN struct group * getgrgid __PROTO((int gid));
__EXTERN struct group * getgrnam __PROTO((const char *name));

#ifdef __USE_BSD
__EXTERN int initgroups __PROTO((const char* __user, _GID_T __groups));
__EXTERN int setgroups __PROTO((_SIZE_T __count, _GID_T* __groups));
#endif
__EXTERN int __initgroups __PROTO((const char* __user, _GID_T __groups));
__EXTERN int __setgroups __PROTO((_SIZE_T __count, _GID_T* __groups));

#ifdef __cplusplus
}
#endif

#endif /* _GRP_H */
