/*  stpcpy.c -- MiNTLib.
    Copyright (C) 1999 Guido Flohr <gufl0000@stud.uni-sb.de>

    This file is part of the MiNTLib project, and may only be used
    modified and distributed under the terms of the MiNTLib project
    license, COPYMINT.  By continuing to use, modify, or distribute
    this file you indicate that you have read the license and
    understand and accept it fully.
*/

#include <string.h>

#ifndef HAVE_WEAK_SYMBOLS
# define __stpcpy stpcpy
#endif

char*
__stpcpy (char* dest, const char* src)
{
  register char* write_crs = dest;
  register const char* read_crs = src;

  do
    *write_crs++ = *read_crs;
  while (*read_crs++ != '\0');

  return write_crs - 1;
}
#ifdef HAVE_WEAK_SYMBOLS
weak_alias (__stpcpy, stpcpy)
#endif
